---
title: ServiceWorkerContainer.ready
slug: Web/API/ServiceWorkerContainer/ready
tags:
  - API
  - Property
  - Reference
  - Service worker API
  - ServiceWorker
  - ServiceWorkerContainer
---
<p>{{APIRef("Service Workers API")}}</p>

<p><span class="seoSummary">The <strong><code>ready</code></strong> read-only property of the {{domxref("ServiceWorkerContainer")}} interface provides a way of delaying code execution until a service worker is active. It returns a {{jsxref("Promise")}} that will never reject, and which waits indefinitely until the {{domxref("ServiceWorkerRegistration")}} associated with the current page has an {{domxref("ServiceWorkerRegistration.active","active")}} worker. Once that condition is met, it resolves with the {{domxref("ServiceWorkerRegistration")}}.</span></p>

<h2 id="Syntax">Syntax</h2>

<pre class="syntaxbox">navigator.serviceWorker.ready.then(function(<em>serviceWorkerRegistration</em>) { ... });</pre>

<h3 id="Value">Value</h3>

<p>A {{jsxref("Promise")}} that will never reject, and which may eventually resolve with a {{domxref("ServiceWorkerRegistration")}}.</p>

<h2 id="Example">Example</h2>

<pre class="brush: js">if ('serviceWorker' in navigator) {
  navigator.serviceWorker.ready
  .then(function(registration) {
    console.log('A service worker is active:', registration.active);

    // At this point, you can call methods that require an active
    // service worker, like registration.pushManager.subscribe()
  });
} else {
  console.log('Service workers are not supported.');
}
</pre>

<h2 id="Specifications">Specifications</h2>

<table class="standard-table">
 <tbody>
  <tr>
   <th scope="col">Specification</th>
   <th scope="col">Status</th>
   <th scope="col">Comment</th>
  </tr>
  <tr>
   <td>{{SpecName('Service Workers', '#navigator-service-worker-ready', 'ServiceWorkerRegistration.ready')}}</td>
   <td>{{Spec2('Service Workers')}}</td>
   <td>Initial definition.</td>
  </tr>
 </tbody>
</table>

<h2 id="Browser_compatibility">Browser compatibility</h2>

<div>

<p>{{Compat("api.ServiceWorkerContainer.ready")}}</p>
</div>
